-- CatPrint for Rift by Vritra

--[[

Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to You under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

--]]

-- Define
local PLAYERID = Inspect.Unit.Lookup("player")
local UPDATE = .2

-- Apprication Variables
local Buff = {}
local LastUpdate = (Inspect.Time.Frame() or 0) + 2
local CatTexVisible = 0
local CatUI = {}

table.insert(Event.Addon.SavedVariables.Load.End, {function(addonName)
	if addonName == "CatPrint" then
		CatPrint = CatPrint or {}
		CatPrint.frameX = CatPrint.frameX or 0
		CatPrint.frameY = CatPrint.frameY or 300
		CatPrint.buffName = CatPrint.buffName or "Vex"
	end
end, "CatPrint", "ValueEnd"})

table.insert(Event.Addon.Load.End, {function(addonName)
	if addonName == "CatPrint" then
		CatUI.Context = UI.CreateContext("CatStamp")
		CatUI.CatFrame = UI.CreateFrame("Frame", "CatFrame", CatUI.Context)
		CatUI.CatFrame:SetVisible(false)
		CatUI.CatFrame:SetPoint(0,0, UIParent, 0,0, CatPrint.frameX, CatPrint.frameY)
		CatUI.CatFrame.lock = true
		
		CatUI.CatTexture = {}

		CatUI.CatTexture[1] = UI.CreateFrame("Texture", "CatTexture1", CatUI.CatFrame)	--sakana
		CatUI.CatTexture[1]:SetPoint(0,0, CatUI.CatFrame, 0,0)
		CatUI.CatTexture[1]:SetTexture("CatPrint", "nyanko.png")
		CatUI.CatTexture[1]:SetVisible(false)

		CatUI.CatTexture[2] = UI.CreateFrame("Texture", "CatTexture2", CatUI.CatFrame)	--asiato1
		CatUI.CatTexture[2]:SetPoint(0,0, CatUI.CatTexture[1], .5,1)
		CatUI.CatTexture[2]:SetTexture("CatPrint", "footPrint.png")
		CatUI.CatTexture[2]:SetVisible(false)

		CatUI.CatTexture[3] = UI.CreateFrame("Texture", "CatTexture3", CatUI.CatFrame)	--2
		CatUI.CatTexture[3]:SetPoint(.5,0, CatUI.CatTexture[2], 0,1)
		CatUI.CatTexture[3]:SetTexture("CatPrint", "footPrint.png")
		CatUI.CatTexture[3]:SetVisible(false)

		CatUI.CatTexture[4] = UI.CreateFrame("Texture", "CatTexture4", CatUI.CatFrame)	--3
		CatUI.CatTexture[4]:SetPoint(0,0, CatUI.CatTexture[3], .5,1)
		CatUI.CatTexture[4]:SetTexture("CatPrint", "footPrint.png")
		CatUI.CatTexture[4]:SetVisible(false)

		CatUI.CatTexture[5] = UI.CreateFrame("Texture", "CatTexture5", CatUI.CatFrame)	--4
		CatUI.CatTexture[5]:SetPoint(.5,0, CatUI.CatTexture[4], 0,1)
		CatUI.CatTexture[5]:SetTexture("CatPrint", "footPrint.png")
        
		CatUI.CatAbiTxt = UI.CreateFrame("Text", "CatText", CatUI.CatFrame)
		CatUI.CatAbiTxt:SetPoint(.5,0, CatUI.CatTexture[5], .5,1)
		CatUI.CatAbiTxt:SetFontSize(15)
		CatUI.CatAbiTxt:SetLayer(1)
		CatUI.CatAbiTxt:SetFontColor(.9,.75,.6,1)
		CatUI.CatAbiTxt:SetText(CatPrint.buffName)
        
		CatUI.CatAbiSdw = UI.CreateFrame("Text", "CatText2", CatUI.CatFrame)
		CatUI.CatAbiSdw:SetPoint(.5,.5, CatUI.CatAbiTxt, .5,.5, 1, 1)
		CatUI.CatAbiSdw:SetFontSize(15)
		CatUI.CatAbiSdw:SetLayer(0)
		CatUI.CatAbiSdw:SetFontColor(0, 0, 0, .5)
		CatUI.CatAbiSdw:SetText(CatPrint.buffName)

		function CatUI.CatFrame.Event:LeftDown()
			if CatUI.CatFrame.lock == false then
				CatUI.CatFrame.mouseDown = true
				local mouse = Inspect.Mouse()
				CatUI.CatFrame.startX = CatUI.CatFrame:GetLeft()
				CatUI.CatFrame.startY = CatUI.CatFrame:GetTop()
				CatUI.CatFrame.mouseStartX = mouse.x
				CatUI.CatFrame.mouseStartY = mouse.y
			end
		end

		function CatUI.CatFrame.Event:MouseMove()
			if CatUI.CatFrame.mouseDown and CatUI.CatFrame.lock == false then
				local mouse = Inspect.Mouse()
				CatPrint.frameX = mouse.x - CatUI.CatFrame.mouseStartX + CatUI.CatFrame.startX
				CatPrint.frameY = mouse.y - CatUI.CatFrame.mouseStartY + CatUI.CatFrame.startY
				CatUI.CatFrame:SetPoint(0,0, UIParent, 0,0, CatPrint.frameX, CatPrint.frameY)
			end
		end

		function CatUI.CatFrame.Event:LeftUp()
			if CatUI.CatFrame.mouseDown then
				CatUI.CatFrame.mouseDown = false
			end
		end

		function CatUI.CatFrame.Event:RightClick()
			if CatUI.CatFrame.lock == false then
				CatUI.CatFrame:SetVisible(false)
				CatUI.CatFrame.lock = true
				CatUI.CatTexture[1]:SetVisible(false)
				CatUI.CatTexture[2]:SetVisible(false)
				CatUI.CatTexture[3]:SetVisible(false)
				CatUI.CatTexture[4]:SetVisible(false)
			end
		end
	end
end, "CatPrint", "InititalSetup"})

local function SetCatText()
	CatUI.CatAbiSdw:SetText(CatPrint.buffName)
	CatUI.CatAbiTxt:SetText(CatPrint.buffName)
end

table.insert(Event.Buff.Add, {function(unit, buff)
	if CatPrint.buffName == nil then return end

	for id, info in pairs(Inspect.Buff.Detail(unit, buff)) do
		if info.name and info.name == CatPrint.buffName and info.caster and info.caster == PLAYERID then
			Buff.id = id
			Buff.info = info
			Buff.unit = unit
			CatTexVisible = 5
			CatUI.CatFrame:SetVisible(true)
			CatUI.CatTexture[1]:SetVisible(false)
			CatUI.CatTexture[2]:SetVisible(false)
			CatUI.CatTexture[3]:SetVisible(false)
			CatUI.CatTexture[4]:SetVisible(false)
		end
	end
end, "CatPrint", "OnBuffAdd"})

table.insert(Event.Buff.Remove, {function(unit, buff)
	for k, v in pairs(buff) do
		if Buff.id and Buff.id == k then
			Buff.id = nil
			CatUI.CatFrame:SetVisible(false)
		end
	end
end, "CatPrint", "OnBuffRemove"})

table.insert(Event.System.Update.Begin, {function()
	local now = Inspect.Time.Frame()
	if (now - LastUpdate) > UPDATE then LastUpdate = now else return end

	if Buff.info == nil or Buff.id == nil then return end

	if (Buff.info.duration and Buff.info.begin) and Buff.info.duration + Buff.info.begin > now then
		local m = ((Buff.info.duration + Buff.info.begin - now) / Buff.info.duration)
		if CatTexVisible == 5 and m < .8 then
			CatUI.CatTexture[4]:SetVisible(true)
			CatTexVisible = 4
		elseif CatTexVisible == 4 and m < .6 then
			CatUI.CatTexture[3]:SetVisible(true)
			CatTexVisible = 3
		elseif CatTexVisible == 3 and m < .4 then
			CatUI.CatTexture[2]:SetVisible(true)
			CatTexVisible = 2
		elseif CatTexVisible == 2 and m < .2 then
			CatUI.CatTexture[1]:SetVisible(true)
			CatTexVisible = 1
		end
	else
		Buff.id = nil
		CatUI.CatFrame:SetVisible(false)
	end
end, "CatPrint", "Update"})

table.insert(Command.Slash.Register("cp"), {function(cmd)
	-- make arg
	local arg = {}
	local i = 1
	for v in string.gmatch(cmd, "[^%s]+") do
		arg[i] = v
		i = i + 1
	end

	-- slash command
	if arg[1] == "set" or arg[1] == "Set" then
		CatUI.CatFrame.lock = false
		CatUI.CatTexture[1]:SetVisible(true)
		CatUI.CatTexture[2]:SetVisible(true)
		CatUI.CatTexture[3]:SetVisible(true)
		CatUI.CatTexture[4]:SetVisible(true)
		CatUI.CatFrame:SetVisible(true)
	elseif arg[1] then
		CatPrint.buffName = cmd
		SetCatText()
		print(CatPrint.buffName)
	else
		print(CatPrint.buffName)
	end
end, "CatPrint", "SlashCommand"})

table.insert(Event.Combat.Death, {function(val)
	for _, v in pairs(val) do
		if v == Buff.unit or v == PLAYERID then
			Buff.id = nil
			CatUI.CatFrame:SetVisible(false)
		end
	end
end, "CatPrint", "OnDeath"})
